Index: /palm/trunk/SOURCE/data_output_module.f90
===================================================================
--- /palm/trunk/SOURCE/data_output_module.f90	(revision 4140)
+++ /palm/trunk/SOURCE/data_output_module.f90	(revision 4141)
@@ -1581,16 +2498,17 @@
 !> @todo Try to combine similar code parts and shorten routine.
 !--------------------------------------------------------------------------------------------------!
-FUNCTION dom_def_att_save( filename, variable_name, attribute, append ) RESULT( return_value )
-
-   CHARACTER(LEN=*), INTENT(IN) ::  filename                 !< name of file
-   CHARACTER(LEN=*), INTENT(IN), OPTIONAL ::  variable_name  !< name of variable
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_def_att_save'  !< name of routine
-
-   INTEGER(iwp) ::  a             !< loop index
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  f             !< loop index
-   INTEGER(iwp) ::  natt          !< number of attributes
-   INTEGER(iwp) ::  return_value  !< return value
+FUNCTION save_attribute_in_database( file_name, variable_name, attribute, append ) &
+            RESULT( return_value )
+
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name      !< name of file
+   CHARACTER(LEN=*), INTENT(IN) ::  variable_name  !< name of variable
+
+   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'save_attribute_in_database'  !< name of routine
+
+   INTEGER ::  a             !< loop index
+   INTEGER ::  d             !< loop index
+   INTEGER ::  f             !< loop index
+   INTEGER ::  natts         !< number of attributes
+   INTEGER ::  return_value  !< return value
 
    LOGICAL             ::  found   !< true if variable or dimension of name 'variable_name' found
@@ -1605,22 +2523,16 @@
    found = .FALSE.
 
-   IF ( PRESENT( variable_name ) )  THEN
-      CALL internal_message( 'debug', routine_name //                            &
-                             ': define attribute "' // TRIM( attribute%name ) // &
-                             '" of variable "' // TRIM( variable_name ) //       &
-                             '" in file "' // TRIM( filename ) // '"' )
-   ELSE
-      CALL internal_message( 'debug', routine_name //                            &
-                             ': define attribute "' // TRIM( attribute%name ) // &
-                             '" in file "' // TRIM( filename ) // '"' )
-   ENDIF
-
-   DO  f = 1, nf
-
-      IF ( TRIM( filename ) == files(f)%name )  THEN
+   CALL internal_message( 'debug', routine_name //                            &
+                          ': define attribute "' // TRIM( attribute%name ) // &
+                          '" of variable "' // TRIM( variable_name ) //       &
+                          '" in file "' // TRIM( file_name ) // '"' )
+
+   DO  f = 1, nfiles
+
+      IF ( TRIM( file_name ) == files(f)%name )  THEN
 
          IF ( files(f)%is_init )  THEN
             return_value = 1
-            CALL internal_message( 'error', routine_name // ': file "' // TRIM( filename ) // &
+            CALL internal_message( 'error', routine_name // ': file "' // TRIM( file_name ) // &
                     '" is already initialized. No further attribute definition allowed!' )
             EXIT
@@ -1628,15 +2540,15 @@
 
          !-- Add attribute to file
-         IF ( .NOT. PRESENT( variable_name ) )  THEN
+         IF ( TRIM( variable_name ) == '' )  THEN
 
             !-- Initialize first file attribute
             IF ( .NOT. ALLOCATED( files(f)%attributes ) )  THEN
-               natt = 1
-               ALLOCATE( files(f)%attributes(natt) )
+               natts = 1
+               ALLOCATE( files(f)%attributes(natts) )
             ELSE
-               natt = SIZE( files(f)%attributes )
+               natts = SIZE( files(f)%attributes )
 
                !-- Check if attribute already exists
-               DO  a = 1, natt
+               DO  a = 1, natts
                   IF ( files(f)%attributes(a)%name == attribute%name )  THEN
                      IF ( append )  THEN
@@ -1655,10 +2567,10 @@
                !-- Extend attribute list by 1
                IF ( .NOT. found )  THEN
-                  ALLOCATE( atts_tmp(natt) )
+                  ALLOCATE( atts_tmp(natts) )
                   atts_tmp = files(f)%attributes
                   DEALLOCATE( files(f)%attributes )
-                  natt = natt + 1
-                  ALLOCATE( files(f)%attributes(natt) )
-                  files(f)%attributes(:natt-1) = atts_tmp
+                  natts = natts + 1
+                  ALLOCATE( files(f)%attributes(natts) )
+                  files(f)%attributes(:natts-1) = atts_tmp
                   DEALLOCATE( atts_tmp )
                ENDIF
@@ -1667,5 +2579,5 @@
             !-- Save new attribute to the end of the attribute list
             IF ( .NOT. found )  THEN
-               files(f)%attributes(natt) = attribute
+               files(f)%attributes(natts) = attribute
                found = .TRUE.
             ENDIF
@@ -1684,11 +2596,11 @@
                      IF ( .NOT. ALLOCATED( files(f)%dimensions(d)%attributes ) )  THEN
                         !-- Initialize first attribute
-                        natt = 1
-                        ALLOCATE( files(f)%dimensions(d)%attributes(natt) )
+                        natts = 1
+                        ALLOCATE( files(f)%dimensions(d)%attributes(natts) )
                      ELSE
-                        natt = SIZE( files(f)%dimensions(d)%attributes )
+                        natts = SIZE( files(f)%dimensions(d)%attributes )
 
                         !-- Check if attribute already exists
-                        DO  a = 1, natt
+                        DO  a = 1, natts
                            IF ( files(f)%dimensions(d)%attributes(a)%name == attribute%name ) &
                            THEN
@@ -1709,10 +2621,10 @@
                         !-- Extend attribute list
                         IF ( .NOT. found )  THEN
-                           ALLOCATE( atts_tmp(natt) )
+                           ALLOCATE( atts_tmp(natts) )
                            atts_tmp = files(f)%dimensions(d)%attributes
                            DEALLOCATE( files(f)%dimensions(d)%attributes )
-                           natt = natt + 1
-                           ALLOCATE( files(f)%dimensions(d)%attributes(natt) )
-                           files(f)%dimensions(d)%attributes(:natt-1) = atts_tmp
+                           natts = natts + 1
+                           ALLOCATE( files(f)%dimensions(d)%attributes(natts) )
+                           files(f)%dimensions(d)%attributes(:natts-1) = atts_tmp
                            DEALLOCATE( atts_tmp )
                         ENDIF
@@ -1721,5 +2633,5 @@
                      !-- Add new attribute to database
                      IF ( .NOT. found )  THEN
-                        files(f)%dimensions(d)%attributes(natt) = attribute
+                        files(f)%dimensions(d)%attributes(natts) = attribute
                         found = .TRUE.
                      ENDIF
@@ -1742,11 +2654,11 @@
                      IF ( .NOT. ALLOCATED( files(f)%variables(d)%attributes ) )  THEN
                         !-- Initialize first attribute
-                        natt = 1
-                        ALLOCATE( files(f)%variables(d)%attributes(natt) )
+                        natts = 1
+                        ALLOCATE( files(f)%variables(d)%attributes(natts) )
                      ELSE
-                        natt = SIZE( files(f)%variables(d)%attributes )
+                        natts = SIZE( files(f)%variables(d)%attributes )
 
                         !-- Check if attribute already exists
-                        DO  a = 1, natt
+                        DO  a = 1, natts
                            IF ( files(f)%variables(d)%attributes(a)%name == attribute%name )  &
                            THEN
@@ -1767,10 +2679,10 @@
                         !-- Extend attribute list
                         IF ( .NOT. found )  THEN
-                           ALLOCATE( atts_tmp(natt) )
+                           ALLOCATE( atts_tmp(natts) )
                            atts_tmp = files(f)%variables(d)%attributes
                            DEALLOCATE( files(f)%variables(d)%attributes )
-                           natt = natt + 1
-                           ALLOCATE( files(f)%variables(d)%attributes(natt) )
-                           files(f)%variables(d)%attributes(:natt-1) = atts_tmp
+                           natts = natts + 1
+                           ALLOCATE( files(f)%variables(d)%attributes(natts) )
+                           files(f)%variables(d)%attributes(:natts-1) = atts_tmp
                            DEALLOCATE( atts_tmp )
                         ENDIF
@@ -1780,5 +2692,5 @@
                      !-- Add new attribute to database
                      IF ( .NOT. found )  THEN
-                        files(f)%variables(d)%attributes(natt) = attribute
+                        files(f)%variables(d)%attributes(natts) = attribute
                         found = .TRUE.
                      ENDIF
@@ -1798,12 +2710,12 @@
                        ': requested dimension/variable "' // TRIM( variable_name ) // &
                        '" for attribute "' // TRIM( attribute%name ) //               &
-                       '" does not exist in file "' // TRIM( filename ) // '"' )
+                       '" does not exist in file "' // TRIM( file_name ) // '"' )
             ENDIF
 
             EXIT
 
-         ENDIF  ! variable_name present
-
-      ENDIF  ! check filename
+         ENDIF  ! variable_name not empty
+
+      ENDIF  ! check file_name
 
    ENDDO  ! loop over files
@@ -1813,166 +2725,10 @@
       CALL internal_message( 'error',                                         &
                              routine_name //                                  &
-                             ': requested file "' // TRIM( filename ) //      &
+                             ': requested file "' // TRIM( file_name ) //     &
                              '" for attribute "' // TRIM( attribute%name ) // &
                              '" does not exist' )
    ENDIF
 
-END FUNCTION dom_def_att_save
-
-!--------------------------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Start with output: clear database from unused files/dimensions, initialize
-!> files and write dimension values to files.
-!--------------------------------------------------------------------------------------------------!
-FUNCTION dom_start_output() RESULT( return_value )
-
-   CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_start_output'  !< name of routine
-
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  f             !< loop index
-   INTEGER(iwp) ::  return_value  !< return value
-
-   INTEGER(KIND=1), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int8          !< target array for dimension values
-   INTEGER(KIND=1), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int8_pointer  !< pointer to target array
-
-   INTEGER(KIND=2), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int16          !< target array for dimension values
-   INTEGER(KIND=2), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int16_pointer  !< pointer to target array
-
-   INTEGER(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_int32          !< target array for dimension values
-   INTEGER(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_int32_pointer  !< pointer to target array
-
-   INTEGER(iwp), DIMENSION(:), ALLOCATABLE, TARGET ::  values_intwp          !< target array for dimension values
-   INTEGER(iwp), DIMENSION(:), POINTER, CONTIGUOUS ::  values_intwp_pointer  !< pointer to target array
-
-   REAL(KIND=4), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real32          !< target array for dimension values
-   REAL(KIND=4), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real32_pointer  !< pointer to target array
-
-   REAL(KIND=8), DIMENSION(:), ALLOCATABLE, TARGET ::  values_real64          !< target array for dimension values
-   REAL(KIND=8), DIMENSION(:), POINTER, CONTIGUOUS ::  values_real64_pointer  !< pointer to target array
-
-   REAL(wp), DIMENSION(:), ALLOCATABLE, TARGET ::  values_realwp          !< target array for dimension values
-   REAL(wp), DIMENSION(:), POINTER, CONTIGUOUS ::  values_realwp_pointer  !< pointer to target array
-
-
-   return_value = 0
-   CALL internal_message( 'debug', routine_name // ': start' )
-
-   !-- Clear database from empty files and unused dimensions
-   IF ( nf > 0 )  return_value = cleanup_database()
-
-   IF ( return_value == 0 )  THEN
-      DO  f = 1, nf
-
-         !-- Skip initialization if file is already initialized
-         IF ( files(f)%is_init )  CYCLE
-
-         CALL internal_message( 'debug', routine_name // ': initialize file "' // &
-                                TRIM( files(f)%name ) // '"' )
-
-         !-- Open file
-         CALL open_output_file( files(f)%format, files(f)%name, files(f)%id, &
-                                return_value=return_value )
-
-         !-- Initialize file header:
-         !-- define dimensions and variables and write attributes
-         IF ( return_value == 0 )  &
-            CALL dom_init_file_header( files(f), return_value=return_value )
-
-         !-- End file definition
-         IF ( return_value == 0 )  &
-            CALL dom_init_end( files(f)%format, files(f)%id, files(f)%name, return_value )
-
-         IF ( return_value == 0 )  THEN
-
-            !-- Flag file as initialized
-            files(f)%is_init = .TRUE.
-
-            !-- Write dimension values into file
-            DO  d = 1, SIZE( files(f)%dimensions )
-               IF ( ALLOCATED( files(f)%dimensions(d)%values_int8 ) )  THEN
-                  ALLOCATE( values_int8(files(f)%dimensions(d)%bounds(1): &
-                                        files(f)%dimensions(d)%bounds(2)) )
-                  values_int8 = files(f)%dimensions(d)%values_int8
-                  values_int8_pointer => values_int8
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_int8_1d=values_int8_pointer )
-                  DEALLOCATE( values_int8 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int16 ) )  THEN
-                  ALLOCATE( values_int16(files(f)%dimensions(d)%bounds(1): &
-                                         files(f)%dimensions(d)%bounds(2)) )
-                  values_int16 = files(f)%dimensions(d)%values_int16
-                  values_int16_pointer => values_int16
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_int16_1d=values_int16_pointer )
-                  DEALLOCATE( values_int16 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_int32 ) )  THEN
-                  ALLOCATE( values_int32(files(f)%dimensions(d)%bounds(1): &
-                                         files(f)%dimensions(d)%bounds(2)) )
-                  values_int32 = files(f)%dimensions(d)%values_int32
-                  values_int32_pointer => values_int32
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_int32_1d=values_int32_pointer )
-                  DEALLOCATE( values_int32 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_intwp ) )  THEN
-                  ALLOCATE( values_intwp(files(f)%dimensions(d)%bounds(1): &
-                                         files(f)%dimensions(d)%bounds(2)) )
-                  values_intwp = files(f)%dimensions(d)%values_intwp
-                  values_intwp_pointer => values_intwp
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_intwp_1d=values_intwp_pointer )
-                  DEALLOCATE( values_intwp )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real32 ) )  THEN
-                  ALLOCATE( values_real32(files(f)%dimensions(d)%bounds(1): &
-                                          files(f)%dimensions(d)%bounds(2)) )
-                  values_real32 = files(f)%dimensions(d)%values_real32
-                  values_real32_pointer => values_real32
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_real32_1d=values_real32_pointer )
-                  DEALLOCATE( values_real32 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_real64 ) )  THEN
-                  ALLOCATE( values_real64(files(f)%dimensions(d)%bounds(1): &
-                                          files(f)%dimensions(d)%bounds(2)) )
-                  values_real64 = files(f)%dimensions(d)%values_real64
-                  values_real64_pointer => values_real64
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_real64_1d=values_real64_pointer )
-                  DEALLOCATE( values_real64 )
-               ELSEIF ( ALLOCATED( files(f)%dimensions(d)%values_realwp ) )  THEN
-                  ALLOCATE( values_realwp(files(f)%dimensions(d)%bounds(1): &
-                                          files(f)%dimensions(d)%bounds(2)) )
-                  values_realwp = files(f)%dimensions(d)%values_realwp
-                  values_realwp_pointer => values_realwp
-                  return_value = dom_write_var( files(f)%name, files(f)%dimensions(d)%name, &
-                                    bounds_start=(/ files(f)%dimensions(d)%bounds(1) /),    &
-                                    bounds_end  =(/ files(f)%dimensions(d)%bounds(2) /),    &
-                                    var_realwp_1d=values_realwp_pointer )
-                  DEALLOCATE( values_realwp )
-               ENDIF
-               IF ( return_value /= 0 )  EXIT
-            ENDDO
-
-         ENDIF
-
-         IF ( return_value /= 0 )  EXIT
-
-      ENDDO
-   ENDIF
-
-   CALL internal_message( 'debug', routine_name // ': finished' )
-
-END FUNCTION dom_start_output
+END FUNCTION save_attribute_in_database
 
 !--------------------------------------------------------------------------------------------------!
@@ -1986,15 +2742,15 @@
    ! CHARACTER(LEN=*), PARAMETER ::  routine_name = 'cleanup_database'  !< name of routine
 
-   INTEGER(iwp) ::  d             !< loop index
-   INTEGER(iwp) ::  f             !< loop index
-   INTEGER(iwp) ::  i             !< loop index
-   INTEGER(iwp) ::  ndim          !< number of dimensions in a file
-   INTEGER(iwp) ::  ndim_used     !< number of used dimensions in a file
-   INTEGER(iwp) ::  nf_used       !< number of used files
-   INTEGER(iwp) ::  nvar          !< number of variables in a file
-   INTEGER(iwp) ::  return_value  !< return value
-
-   LOGICAL, DIMENSION(1:nf)           ::  file_is_used       !< true if file contains variables
-   LOGICAL, DIMENSION(:), ALLOCATABLE ::  dimension_is_used  !< true if dimension is used by any variable
+   INTEGER ::  d             !< loop index
+   INTEGER ::  f             !< loop index
+   INTEGER ::  i             !< loop index
+   INTEGER ::  ndims         !< number of dimensions in a file
+   INTEGER ::  ndims_used    !< number of used dimensions in a file
+   INTEGER ::  nfiles_used   !< number of used files
+   INTEGER ::  nvars         !< number of variables in a file
+   INTEGER ::  return_value  !< return value
+
+   LOGICAL, DIMENSION(1:nfiles)             ::  file_is_used       !< true if file contains variables
+   LOGICAL, DIMENSION(:),       ALLOCATABLE ::  dimension_is_used  !< true if dimension is used by any variable
 
    TYPE(dimension_type), DIMENSION(:), ALLOCATABLE ::  used_dimensions  !< list of used dimensions
@@ -2007,5 +2763,5 @@
    !-- Flag files which contain output variables as used
    file_is_used(:) = .FALSE.
-   DO  f = 1, nf
+   DO  f = 1, nfiles
       IF ( ALLOCATED( files(f)%variables ) )  THEN
          file_is_used(f) = .TRUE.
@@ -2014,8 +2770,8 @@
 
    !-- Copy flagged files into temporary list
-   nf_used = COUNT( file_is_used )
-   ALLOCATE( used_files(nf_used) )
+   nfiles_used = COUNT( file_is_used )
+   ALLOCATE( used_files(nfiles_used) )
    i = 0
-   DO  f = 1, nf
+   DO  f = 1, nfiles
       IF ( file_is_used(f) )  THEN
          i = i + 1
@@ -2026,11 +2782,11 @@
    !-- Replace file list with list of used files
    DEALLOCATE( files )
-   nf = nf_used
-   ALLOCATE( files(nf) )
+   nfiles = nfiles_used
+   ALLOCATE( files(nfiles) )
    files = used_files
    DEALLOCATE( used_files )
 
    !-- Check every file for unused dimensions
-   DO  f = 1, nf
+   DO  f = 1, nfiles
 
       !-- If a file is already initialized, it was already checked previously
@@ -2038,11 +2794,11 @@
 
       !-- Get number of defined dimensions
-      ndim = SIZE( files(f)%dimensions )
-      ALLOCATE( dimension_is_used(ndim) )
+      ndims = SIZE( files(f)%dimensions )
+      ALLOCATE( dimension_is_used(ndims) )
 
       !-- Go through all variables and flag all used dimensions
-      nvar = SIZE( files(f)%variables )
-      DO  d = 1, ndim
-         DO  i = 1, nvar
+      nvars = SIZE( files(f)%variables )
+      DO  d = 1, ndims
+         DO  i = 1, nvars
             dimension_is_used(d) = &
                ANY( files(f)%dimensions(d)%name == files(f)%variables(i)%dimension_names )
@@ -2052,8 +2808,8 @@
 
       !-- Copy used dimensions to temporary list
-      ndim_used = COUNT( dimension_is_used )
-      ALLOCATE( used_dimensions(ndim_used) )
+      ndims_used = COUNT( dimension_is_used )
+      ALLOCATE( used_dimensions(ndims_used) )
       i = 0
-      DO  d = 1, ndim
+      DO  d = 1, ndims
          IF ( dimension_is_used(d) )  THEN
             i = i + 1
@@ -2064,6 +2820,6 @@
       !-- Replace dimension list with list of used dimensions
       DEALLOCATE( files(f)%dimensions )
-      ndim = ndim_used
-      ALLOCATE( files(f)%dimensions(ndim) )
+      ndims = ndims_used
+      ALLOCATE( files(f)%dimensions(ndims) )
       files(f)%dimensions = used_dimensions
       DEALLOCATE( used_dimensions )
@@ -2079,14 +2835,14 @@
 !> Open requested output file.
 !--------------------------------------------------------------------------------------------------!
-SUBROUTINE open_output_file( file_format, filename, file_id, return_value )
+SUBROUTINE open_output_file( file_format, file_name, file_id, return_value )
 
    CHARACTER(LEN=*), INTENT(IN) ::  file_format  !< file format chosen for file
-   CHARACTER(LEN=*), INTENT(IN) ::  filename     !< name of file to be checked
+   CHARACTER(LEN=*), INTENT(IN) ::  file_name    !< name of file to be checked
 
    CHARACTER(LEN=*), PARAMETER ::  routine_name = 'open_output_file'  !< name of routine
 
-   INTEGER(iwp), INTENT(OUT) ::  file_id              !< file ID
-   INTEGER(iwp)              ::  output_return_value  !< return value of a called output routine
-   INTEGER(iwp), INTENT(OUT) ::  return_value         !< return value
+   INTEGER, INTENT(OUT) ::  file_id              !< file ID
+   INTEGER              ::  output_return_value  !< return value of a called output routine
+   INTEGER, INTENT(OUT) ::  return_value         !< return value
 
 
@@ -2097,11 +2853,11 @@
 
       CASE ( 'binary' )
-         CALL binary_open_file( 'binary', filename, file_id, output_return_value )
+         CALL binary_open_file( 'binary', file_name, file_id, output_return_value )
 
       CASE ( 'netcdf4-serial' )
-         CALL netcdf4_open_file( 'serial', filename, file_id, output_return_value )
+         CALL netcdf4_open_file( 'serial', file_name, file_id, output_return_value )
 
       CASE ( 'netcdf4-parallel' )
-         CALL netcdf4_open_file( 'parallel', filename, file_id, output_return_value )
+         CALL netcdf4_open_file( 'parallel', file_name, file_id, output_return_value )
 
       CASE DEFAULT
@@ -2113,10 +2869,10 @@
       return_value = output_return_value
       CALL internal_message( 'error', routine_name // &
-                             ': error while opening file "' // TRIM( filename ) // '"' )
+                             ': error while opening file "' // TRIM( file_name ) // '"' )
    ELSEIF ( return_value /= 0 )  THEN
-      CALL internal_message( 'error', routine_name //                              &
-                                      ': file "' // TRIM( filename ) //            &
-                                      '": file format "' // TRIM( file_format ) // &
-                                      '" not supported' )
+      CALL internal_message( 'error', routine_name //                     &
+                             ': file "' // TRIM( file_name ) //           &
+                             '": file format "' // TRIM( file_format ) // &
+                             '" not supported' )
    ENDIF
 
@@ -2126,13 +2882,13 @@
 ! Description:
 ! ------------
-!> Define attributes, dimensions and variables.
-!--------------------------------------------------------------------------------------------------!
-SUBROUTINE dom_init_file_header( file, return_value )
-
-   ! CHARACTER(LEN=*), PARAMETER ::  routine_name = 'dom_init_file_header'  !< name of routine
-
-   INTEGER(iwp)              ::  a             !< loop index
-   INTEGER(iwp)              ::  d             !< loop index
-   INTEGER(iwp), INTENT(OUT) ::  return_value  !< return value
+!> Initialize attributes, dimensions and variables in a file.
+!--------------------------------------------------------------------------------------------------!
+SUBROUTINE init_file_header( file, return_value )
+
+   ! CHARACTER(LEN=*), PARAMETER ::  routine_name = 'init_file_header'  !< name of routine
+
+   INTEGER              ::  a             !< loop index
+   INTEGER              ::  d             !< loop index
+   INTEGER, INTENT(OUT) ::  return_value  !< return value
 
    TYPE(file_type), INTENT(INOUT) ::  file  !< initialize header of this file
@@ -2144,5 +2900,6 @@
    IF ( ALLOCATED( file%attributes ) )  THEN
       DO  a = 1, SIZE( file%attributes )
-         return_value = write_attribute( file%format, file%id, file%name, var_id=no_var_id, &
+         return_value = write_attribute( file%format, file%id, file%name,     &
+                                         variable_id=no_id, variable_name='', &
                                          attribute=file%attributes(a) )
          IF ( return_value /= 0 )  EXIT
@@ -2158,16 +2915,16 @@
 
             !-- Initialize non-masked dimension
-            CALL init_file_dimension( file%format, file%id, file%name,     &
-                    file%dimensions(d)%id, file%dimensions(d)%var_id,      &
-                    file%dimensions(d)%name, file%dimensions(d)%data_type, &
-                    file%dimensions(d)%length, return_value )
+            CALL init_file_dimension( file%format, file%id, file%name,       &
+                    file%dimensions(d)%id, file%dimensions(d)%name,          &
+                    file%dimensions(d)%data_type, file%dimensions(d)%length, &
+                    file%dimensions(d)%variable_id, return_value )
 
          ELSE
 
             !-- Initialize masked dimension
-            CALL init_file_dimension( file%format, file%id, file%name,     &
-                    file%dimensions(d)%id, file%dimensions(d)%var_id,      &
-                    file%dimensions(d)%name, file%dimensions(d)%data_type, &
-                    file%dimensions(d)%length_mask, return_value )
+            CALL init_file_dimension( file%format, file%id, file%name,            &
+                    file%dimensions(d)%id, file%dimensions(d)%name,               &
+                    file%dimensions(d)%data_type, file%dimensions(d)%length_mask, &
+                    file%dimensions(d)%variable_id, return_value )
 
          ENDIF
@@ -2177,6 +2934,6 @@
             DO  a = 1, SIZE( file%dimensions(d)%attributes )
                return_value = write_attribute( file%format, file%id, file%name, &
-                                 var_id=file%dimensions(d)%var_id,              &
-                                 var_name=file%dimensions(d)%name,              &
+                                 variable_id=file%dimensions(d)%variable_id,    &
+                                 variable_name=file%dimensions(d)%name,         &
                                  attribute=file%dimensions(d)%attributes(a) )
                IF ( return_value /= 0 )  EXIT
@@ -2190,5 +2947,6 @@
       !-- Save dimension IDs for variables wihtin database
       IF ( return_value == 0 )  &
-         CALL collect_dimesion_ids_for_variables( file%variables, file%dimensions, return_value )
+         CALL collect_dimesion_ids_for_variables( file%name, file%variables, file%dimensions, &
+                                                  return_value )
 
       !-- Initialize file variables
@@ -2205,6 +2963,6 @@
                DO  a = 1, SIZE( file%variables(d)%attributes )
                   return_value = write_attribute( file%format, file%id, file%name, &
-                                    var_id=file%variables(d)%id,                   &
-                                    var_name=file%variables(d)%name,               &
+                                    variable_id=file%variables(d)%id,              &
+                                    variable_name=file%variables(d)%name,          &
                                     attribute=file%variables(d)%attributes(a) )
                   IF ( return_value /= 0 )  EXIT
